<template>
  <div class="q-pa-md">
    <div>
      <h1>  View & Generate Reports </h1>

      <div class="row">
        <div class="col-sm-3 col-12 text-white">
          <q-select  outlined stack-label
                     v-model="selectedDomain"
                     :options="domainOptions"
                     color="indigo-8"
                     label="Select Domain"
                     :options-dense=true />
        </div>
      </div>

      <div class="row">
        <div class="col-sm-3 col-12 text-white">
          <span >. </span>
        </div>
      </div>

      <div class="row">
        <div class="col-sm-3 col-12 text-white" v-show="showReportOptions">
          <q-banner rounded dense class="bg-grey-3 text-black q-pa-md" >
            <b>Select a report to generate:</b>
            <q-option-group
              :options="reportOptions"
              label="Select a Report"
              type="radio"
              v-model="selectedReport"
            />
          </q-banner>
        </div>
      </div>
    </div>

    <div class="q-pa-md">
      <div class="q-gutter-sm">
        <q-checkbox v-model="force" label="force - will query Cisco EoX API and disregard most recent results" />
      </div>
      <div class="q-px-sm">
      </div>
    </div>

    <div class="row">
      <div class="actions" align="right" style="max-width: 130px">
          <q-btn color="light-green-4" @click="generateReport" :disable="!showReportOptions">
            <div>Get Report</div>
          </q-btn>
      </div>

      <div style="max-width: 130px" class="text-white">
        <span >. . .</span>
      </div>

      <div class="actions" align="right" style="max-width: 140px">
        <q-btn color="light-green-4" @click="refreshReportPage" :disable="showReportOptions">
          <div>Clear Results</div>
        </q-btn>
      </div>

    </div>

    <div style="max-width: 130px" class="text-white">
      <span >. . .</span>
    </div>

    <div class="row" v-show="EOXFileName" style="max-width: 400px">

      <q-banner rounded dense class="bg-light-green-4 text-black q-pa-md" >
        Report generated. Get csv file:
        <q-chip dense clickable @click="downloadFile(EOXFileName + '.csv')" icon="save_alt">.csv</q-chip>
      </q-banner>
    </div>



  </div>
</template>

<script>
export default {
  data() {
    return {
      showReportOptions: true,
      selectedDomain: null,
      domainOptions: [],
      selectedReport: null,
      reportOptions: [
        { label: 'EoX by Product ID', value: 'pid' },
        { label: 'EoX by Serial Number', value: 'sn'},
      ],
      EOXFileName: '',
      force: false
    }
  },
  mounted() {
     this.fetchDomainsData();
  },
  watch:{
    selectedReport: function (val) {
      if (val === 'sn'){
        this.TableName = `EOXBySerialNumber Report for ${this.selectedDomain}`
      }
      else if ( val === 'pid'){
        this.TableName = `EOXByProductID Report for ${this.selectedDomain}`
      }
    }
  },
  methods: {
    fetchDomainsData(){
      const url = `domains`
      this.$axios.get(url)
        .then(response => {
          let i
          for (i in response.data){
            this.domainOptions.push(response.data[i].id);
          }
          console.log(response.data)
        })
        .catch((error) => {
          this.$q.dialog({
            title: 'WARNING!',
            dark: true,
            color: 'red',
            message: error.response.data
          }).onOk(() => {
          })
        })
        .finally(() => {
          this.$q.loading.hide();
        })
    },
    generateReport(){
      this.showReportOptions = false;
      this.$q.loading.show();
      this.EOXFileName = '';
      const url = `reports/${this.selectedReport}/${this.selectedDomain}`
      const json = {'force': this.force}
      this.$axios.put(url, json)
        .then(response => {
          this.EOXFileName = response.data.FileName;
          console.log('FileName', this.EOXFileName)
        })
        .catch(() => this.notify('Ops, unexpected error. Please, try again later.', 'error'))
        .finally(() => {
          this.$q.loading.hide();
          // console.log(this.EOXRecordTableData)
        })
    },
    notify(message, icon = 'check') {
      this.$q.notify({icon, position: 'top', message})
    },
    downloadFile(fileName){
      this.$axios({
        method: 'get',
        url: `/download/${fileName}`,
        responseType: 'arraybuffer'
      })
        .then(response => {

          this.forceFileDownload(response, fileName)

        })
        .catch(() => console.log('error occured'))
    },
    forceFileDownload(response, fileName){
      const url = window.URL.createObjectURL(new Blob([response.data]))
      const link = document.createElement('a')
      link.href = url
      link.setAttribute('download', fileName) //or any other extension
      document.body.appendChild(link)
      link.click()
    },
    refreshReportPage(){
      this.showReportOptions = true
      this.EOXRecordTableData = []
      this.EOXErrorsData = []
    }
  }
}
</script>

<style lang="stylus">
  h1
    font-size 1.5rem
    line-height 2rem

  h2
    font-size 0.9rem
    line-height 2rem

  .actions
    margin-top 20px

  .info
    background-color rgb(247, 232, 236)

  .q-chip--dense
    font-size 14px
</style>
